// Code generated by github.com/99designs/gqlgen, DO NOT EDIT.

package model

// Type that represents an Address Entity
type Address struct {
	// Address Line with optional number
	AddressLine *string `json:"addressLine"`
	// City
	City *string `json:"city"`
	// Region (optional)
	Region *string `json:"region"`
	// Postal Code
	PostalCode *string `json:"postalCode"`
	// Country (optional)
	Country *string `json:"country"`
}

// Input that represents an Entity's Key (used in deletion and retriveal per key)
type KeyInput struct {
	// Key of an Entity
	Key string `json:"key"`
}

// Input that represents a New/Updated Address Entity
type NewAddress struct {
	// Address Line with optional number
	AddressLine *string `json:"addressLine"`
	// City
	City *string `json:"city"`
	// Region (optional)
	Region *string `json:"region"`
	// Postal Code
	PostalCode *string `json:"postalCode"`
	// Country (optional)
	Country *string `json:"country"`
}

// Input that represents a New Planogram Point of the vending machine Entity
type NewPlanogramPoint struct {
	// Position of a Product in a Vending Machine
	Position string `json:"position"`
	// Product key in a specific position in a Vending Machine
	Product string `json:"product"`
	// Product Quantity in this position at data collection moment
	ActualQuantity float64 `json:"actualQuantity"`
	// Product Quantity added in this position. Must be less than the one in the products table (Warehouse)
	AddedQuantity float64 `json:"addedQuantity"`
	// DateTime (Unix date Int) of creation of the planogram point
	CreatedAt int `json:"createdAt"`
	// DateTime (Unix date Int) of last update of the planogram point
	LastUpdatedAt int `json:"lastUpdatedAt"`
}

// Input that represents a New Store Entity
type NewStore struct {
	// Name of the store
	Name string `json:"name"`
	// Address of the store
	Address *NewAddress `json:"address"`
	// Vending Machines in store (optional)
	VendingMachines []*NewVendingMachine `json:"vendingMachines"`
	// Tags (types of locations) of the Store (optional)
	Tags []*string `json:"tags"`
}

// Input that represents a New Vending Machine Entity
type NewVendingMachine struct {
	// Name of the Vending Machine model
	Name string `json:"name"`
	// List of Planogram Points of the vending machine (optional)
	Planogram []*NewPlanogramPoint `json:"planogram"`
	// Typology ('Hot' or 'Cold') of the Vending Machine model
	Typology string `json:"typology"`
}

// Input that represents a New Vending Machine model Entity
type NewVendingMachineModel struct {
	// Name of the Vending Machine model
	Name string `json:"name"`
	// Typology ('Hot' or 'Cold') of the Vending Machine model
	Typology string `json:"typology"`
}

// Type that represents a Vending Machine's Planogram Point Entity
type PlanogramPoint struct {
	// Position of a Product in a Vending Machine
	Position string `json:"position"`
	// Product (partial return: key brand name ean quantity typology) in a specific position in a Vending Machine
	Product *Product `json:"product"`
	// Product Quantity in this position at data collection moment
	ActualQuantity float64 `json:"actualQuantity"`
	// Product Quantity added in this position. Must be less than the one in the products table (Warehouse)
	AddedQuantity float64 `json:"addedQuantity"`
	// DateTime (Unix date Int) of creation of the planogram point
	CreatedAt int `json:"createdAt"`
	// DateTime (Unix date Int) of last update of the planogram point
	LastUpdatedAt int `json:"lastUpdatedAt"`
}

type Product struct {
	Key      *string  `json:"key"`
	Brand    *string  `json:"brand"`
	Name     *string  `json:"name"`
	Ean      *string  `json:"ean"`
	Quantity *float64 `json:"quantity"`
	Typology *string  `json:"typology"`
}

func (Product) IsEntity() {}

// Type that represents an Entity's Key
type ReturnKey struct {
	// Key of an Entity
	Key string `json:"key"`
}

// Type that represents a Store Entity
type Store struct {
	// Key in DB of the store
	Key *string `json:"key"`
	// Name of the store
	Name *string `json:"name"`
	// Address of the store
	Address *Address `json:"address"`
	// Vending Machines in store (optional)
	VendingMachines []*VendingMachine `json:"vendingMachines"`
	// Tags (types of locations) of the Store (optional)
	Tags []*string `json:"tags"`
}

func (Store) IsEntity() {}

// Input that represents an Updated Store Entity
type StoreInput struct {
	// Key in DB of the existing store
	Skey string `json:"skey"`
	// Name of the store
	Name *string `json:"name"`
	// Address of the store
	Address *NewAddress `json:"address"`
	// Vending Machines in store (optional)
	VendingMachines []*VendingMachineInput `json:"vendingMachines"`
	// Tags (types of locations) of the Store (optional)
	Tags []*string `json:"tags"`
}

// Input that represents a Store Entity's Key (used in deletion and retriveal per key)
type StoreKeyInput struct {
	// Key of a Store Entity
	Key string `json:"key"`
	// Flag that indicates if also the Vending Machines associated to the specific store must be deleted
	DeleteVM bool `json:"deleteVm"`
}

// Type that represents a Vending Machine Entity
type VendingMachine struct {
	// Key in DB of the Vending Machine
	Key *string `json:"key"`
	// Name of the Vending Machine model
	Name *string `json:"name"`
	// Typology ('Hot' or 'Cold') of the Vending Machine model
	Typology *string `json:"typology"`
	// List of Planogram Points of the vending machine (optional)
	Planogram []*PlanogramPoint `json:"planogram"`
}

// Input that represents an Updated Vending Machine Entity
type VendingMachineInput struct {
	// Key in DB of the existing vending machine
	Vmkey *string `json:"vmkey"`
	// Name of the Vending Machine model
	Name *string `json:"name"`
	// Typology ('Hot' or 'Cold') of the Vending Machine model
	Typology *string `json:"typology"`
	// List of Planogram Points of the vending machine (optional)
	Planogram []*NewPlanogramPoint `json:"planogram"`
	// Flag that indicates is this Vending Machine must be deleted
	Isdeleted bool `json:"isdeleted"`
}

// Type that represents a Vending Machine model Entity
type VendingMachineModel struct {
	// Key in DB of the Vending Machine model
	Key *string `json:"key"`
	// Name of the Vending Machine model
	Name *string `json:"name"`
	// Typology ('Hot' or 'Cold') of the Vending Machine model
	Typology *string `json:"typology"`
}

// Input that represents an Updated Vending Machine model Entity
type VendingMachineModelInput struct {
	// Key in DB of the existing vending machine model
	Vmmkey string `json:"vmmkey"`
	// Name of the Vending Machine model
	Name *string `json:"name"`
	// Typology ('Hot' or 'Cold') of the Vending Machine model
	Typology *string `json:"typology"`
}
